> For the complete documentation index, see [llms.txt](https://docs.petje.af/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.petje.af/petje.af-api/authentication/tokens.md).

# Tokens

## Generate tokens

<mark style="color:green;">`POST`</mark> `https://api.petjeaf.com/v1/oauth2/tokens`

This endpoint allows you to exchange an `authorization_code` or `refresh_token` for a valid `access_token`\
\
**Use `application/x-www-form-urlencoded` for the POST request**

#### Request Body

| Name           | Type   | Description                                                                                                                                                                                     |
| -------------- | ------ | ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| client\_id     | string | The client ID from your client app                                                                                                                                                              |
| client\_secret | string | The client secret key from your Client App                                                                                                                                                      |
| grant\_type    | string | If you wish to exchange your auth code for an access token, use grant type `authorization_code`. If you wish to renew your access token with your refresh token, use grant type `refresh token` |
| code           | string | The authorization code you've received when creating the authorization. This field is required when using gran type `authorization_code`                                                        |
| refresh\_token | string | The refresh token you've received when creating the authorization. This field is required when using grant type `refresh_token`                                                                 |

{% tabs %}
{% tab title="200 Tokens successfully retrieved. The access\_token is a JSON Web Token with the name, email and id after decoding." %}

```
{
    "access_token": "ACCESS TOKEN (JWT)",
    "token_type": "Bearer",
    "expires_in": 3599,
    "refresh_token": "REFRESH TOKEN",
    "scope": "memberships.read"
}
```

{% endtab %}

{% tab title="400 There was an error while creating your tokens" %}

```
{
    "status": 400,
    "title": "Bad Request",
    "detail": "Invalid grant: authorization code is invalid",
    "_links": {
        "documentation": {
            "href": "https://docs.petje.af",
            "type": "text/html"
        }
    }
}
```

{% endtab %}
{% endtabs %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.petje.af/petje.af-api/authentication/tokens.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
